unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Data, Graph, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    SpinEdit1: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    FData: TData;
    FGraph: TGraph;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FData := TData.Create;
  FData.Measure := mt44;

  FGraph := TGraph.Create(self);
  with FGraph do
  begin
    Parent := ScrollBox1;
    BoundsRect := Bounds(0, 0, 0, 72);
    Data := FData;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FGraph.Free;
  FData.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    FData.LoadFromFile(OpenDialog1.FileName);
    FGraph.Update;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i, j: integer;
  t: PTone;

begin
  for i := 0 to FData.Count - 1 do
  begin
    t := FData.GetTone(i);
    if t^.Freq = 0 then
      continue;
    j := t^.Freq + SpinEdit1.Value;

    if not (j in [1..24]) then
    begin
      ShowMessage('Nelze provst transpozici - nkter noty jsou mimo rozsah.');
      exit;
    end;
  end;

  for i := 0 to FData.Count - 1 do
  begin
    t := FData.GetTone(i);
    if t^.Freq = 0 then
     continue;
    t^.Freq := t^.Freq + SpinEdit1.Value;
  end;

  FGraph.Update;
end;

end.
